//-----------------------------------------------------------------------------
// drawer.m
//
// Example of a simple drawer
//
// created by FrisbeeMonkey
//-----------------------------------------------------------------------------

#include "D:\maki\mc\lib\std.mi"

//declares global variables for use in script
Global Group DrawerGrp;
Global Group ButtonGroup;
Global Button TheButton;
Global Layer Drawer, DrawerInfo, DrawerButton;
Global Int DrawerStatus; //0 = closed, 1 = open
Global Int StartX, StartY, EndX, EndY;
Global Container yourContainerVar;
Global String layoutx;


//when the script is loaded, do this
System.onScriptLoaded() {

//gets the group that has the objects we want
layoutx = System.getPrivateString("Main", "Layout", "normal");
DrawerGrp = getContainer("main").getLayout(layoutx).getObject("DrawerGroup");
ButtonGroup = getContainer("main").getLayout(layoutx).getObject("ButtonGroup");
yourContainerVar = system.getContainer("main");
DrawerStatus = 0;

Drawer = DrawerGrp.findObject("Drawer");
  DrawerInfo = DrawerGrp.findObject("DrawerInfo");
  TheButton = ButtonGroup.findObject("DrawerButton");
  StartX = StringToInteger(DrawerGrp.getXMLparam("x"));
  StartY = StringToInteger(DrawerGrp.getXMLparam("y"));
  EndX = StringToInteger(DrawerInfo.getXMLparam("x"));
  EndY = StringToInteger(DrawerInfo.getXMLparam("y"));
}

yourContainerVar.onSwitchToLayout(Layout newlayout) {
  System.setPrivateString("Matrix", "Layout", newlayout.getxmlparam("id"));
  DrawerGrp = newlayout.getObject("DrawerGroup");
  ButtonGroup = newlayout.getObject("ButtonGroup");

  Drawer = DrawerGrp.findObject("Drawer");
  DrawerInfo = DrawerGrp.findObject("DrawerInfo");
  TheButton = ButtonGroup.findObject("DrawerButton");
  StartX = StringToInteger(DrawerGrp.getXMLparam("x"));
  StartY = StringToInteger(DrawerGrp.getXMLparam("y"));
  EndX = StringToInteger(DrawerInfo.getXMLparam("x"));
  EndY = StringToInteger(DrawerInfo.getXMLparam("y"));
}

//when the left mouse button is released within Drawer, do this
TheButton.onLeftButtonUp(int x, int y) {
  if (DrawerStatus == 0) {  // if our Drawer is closed, make it slide open
    if (!DrawerGrp.isGoingToTarget()) {  //makes sure it isn't already moving
      DrawerGrp.setTargetX(0);  //set the x coordinate you want the drawer to slide to
      DrawerGrp.setTargetY(167);  //set the y coordinate you want the drawer to slide to
      DrawerGrp.setTargetSpeed(1);  //sets the speed the drawer will slide at(higher is slower)
      DrawerGrp.gotoTarget();  //now that we have our target values and speed, start moving!
      DrawerStatus = 1;  //Change the flag to Open
    }
  }
  else {  // if our Drawer is open, make it slide closed
    if (!DrawerGrp.isGoingToTarget()) {  //makes sure it isn't already moving
      DrawerGrp.setTargetX(0);  //set the x coordinate you want the drawer to slide back to
      DrawerGrp.setTargetY(-2);   //set the y coordinate you want the drawer to slide back to
      DrawerGrp.setTargetSpeed(1);  //sets the speed the drawer will slide at(higher is slower)
      DrawerGrp.gotoTarget();  //now that we have our target values and speed, start moving!
      DrawerStatus = 0;  //Change the flag to Closed
    }
  }
}